<?php

/*
 De functie toonArtikelenLijst voert de sql query voor 
 de productenlist uit op de database en maakt met het resultaat van deze
 query een tabel in html.
 Deze html wordt geretourneerd naar de aanroepende code. 
 */
function toonArtikelenLijst()
{
   global $db; // Verwijst naar de connectie in het aanroepende php document
   global $melding; // Komt straks van database.ph
   // maak verbinding
   if(!$db) $db=maakVerbinding();
   $uitvoer="";
   if(!$db) // test verbinding
   {
    // mislukt
    $uitvoer="Er is geen database connectie! ".$melding;
   }
   else
   {
	 try{
	  $opdracht = $db->prepare("SELECT * FROM product");
	  $opdracht->execute();
      // resultaat tot uitvoer verwerken
      // maken tabel 
      $uitvoer .= "<table summary=''>\n";
      $uitvoer .= "<tr>";
      $uitvoer .= "<td>nummer</td>";
      $uitvoer .= "<td>naam</td>";
      $uitvoer .= "<td>prijs</td>";
      $uitvoer .= "<td>voorraad</td>";
      $uitvoer .= "<td>omschrijving</td>";
      $uitvoer .= "<td>wijzig</td>";
      $uitvoer .= "<td>verwijder</td>";
      $uitvoer .= "</tr>\n";
      // lus door alle rijen aanezig in het resultaat
	 while(
		list($nummer,$naam,$prijs,$voorraad, $omschrijving) = 
			$opdracht->fetch(PDO::FETCH_NUM))
      {
         $uitvoer .= "<tr><td>$nummer</td><td>$naam</td><td>$prijs</td><td>$voorraad</td><td>$omschrijving</td>";
         $uitvoer .= "<td><form action='{$_SERVER['PHP_SELF']}' method='post'>";
         $uitvoer .= "<input type='hidden' name='productid' value=$nummer>";
         $uitvoer .= "<input type='submit' name='actie' value='wijzig'></form></td>";
         $uitvoer .= "<td><form  action='{$_SERVER['PHP_SELF']}' method='post'>";
         $uitvoer .= "<input type='hidden' name='productid' value=$nummer>";
         $uitvoer .= "<input type='submit' name='actie' value='verwijder'></form></td></tr>";
         $uitvoer .= "</tr>\n"; 
      }
      $uitvoer .="</table>";
     }
	 catch(PDOException $e) {
	    $uitvoer .= "<br/>Fout in query" .  $e->getMessage();
     }
   }
   //sluit database
   verbreekVerbinding();         
   return $uitvoer;    // Stuur de waarde van $uitvoer terug     
}


/**
 * toonArtikelInvoerTabel toont de tabel waarmee een product kan worden ingevoerd
 * of het resultaat van de invoer actie kan laten zien
 * param $productEnFout: lijst van producteigenschappen bestaande uit 
 * 4 invoer velden en eventuele fouten
 *		[
			[naam,foutnaam],
			[prijs,foutprijs],
			[voorraad,foutvoorraad],
			[omschrijving,omschrijving],
 *		]
 * param $alsFormulier true als formulier getoond moet worden, 
                       false als alleen de informatie getoond moet worden
 */
function toonArtikelInvoerTabel($productEnFout,$alsFormulier)
{
 $invoer1="";
 $invoer2="";
 $invoer3="";
 $invoer4="";
 $invoerknop="";
 // Voeg hier eigen commentaar toe.
 // print_r($productEnFout);
 // Voeg hier eigen commentaar toe.
 if($alsFormulier)
 {
 	$invoer1="<input name='naam' value='{$productEnFout[0][0]}'/>"; // naam
 	$invoer2="<input name='prijs' value='{$productEnFout[1][0]}'/>"; // prijs
	$invoer3="<input name='voorraad' value='{$productEnFout[2][0]}'/>"; // voorraad
	$invoer4="<textarea name='omschrijving'/>{$productEnFout[3][0]}</textarea>"; // omschrijving
	
	$invoerknop=<<<END
  <tr>
    <td colspan="3">
      <input type="submit" name="actie" value="Invoeren"/>
   </td>
  </tr>
END;
 }
 else
 {
	$invoer1=$productEnFout[0][0]; // naam
	$invoer2=$productEnFout[1][0]; // prijs
	$invoer3=$productEnFout[2][0]; // voorraad
 	$invoer4=$productEnFout[3][0]; // omschrijving
 }
 // Voeg hier eigen commentaar toe.
 $uitvoer=<<<END
  <h3>Voer artikel in</h3>
  <table>
  <tr>
    <td>Geef naam artikel</td>
    <td>$invoer1</td>
    </td>
    <td>{$productEnFout[0][1]}</td>
  </tr>
  <tr>
    <td>Geef prijs</td>
    <td>$invoer2</td>
    <td>{$productEnFout[1][1]}</td>
  </tr>
  <tr>
    <td>Geef aantal in voorraad</td>
    <td>$invoer3</td>
    <td>{$productEnFout[2][1]}</td>
  </tr>
  <tr>
    <td>Geef omschrijving</td>
    <td>$invoer4</td>
    <td>{$productEnFout[3][1]}</td>
  </tr>
  $invoerknop
  </table>
END;
 return $uitvoer;
}

/*
 * artikelInvoeren leest de invoer uit de $_POST variabele,
 * test de invoer, geeft foutmeldingen bij mislukkingen en voegt als
 * er niets misgaat een record toe aan de database. 
 * param &$db: verwijzing naar de database
 */
function artikelInvoeren(&$db)
{
 $fout1="";
 $fout2="";
 $fout3="";
 $fout4="";
 $naam = "";
 $prijs = "";
 $voorraad = "";
 $omschrijving = "";
 $uitvoer ="";
 $melding="";

 //verbinding maken met database
 if(!$db) maakVerbinding($db,$melding);
 if(!$db) // test verbinding
 {
    // mislukt
    $uitvoer=$melding;
 }
 else
 {
   // isset is een functie die kijkt of een element in een array bestaat
   // post variabelen ophalen 
   // https://www.w3schools.com/php/php_mysql_prepared_statements.asp
   //  prepared statements worden gebruikt om sql injection te voorkomen
   try{
		$opdracht = $db->prepare(
		 "INSERT INTO product (naam,prijs,voorraad,omschrijving) VALUES (:naam, :prijs, :voorraad, :omschrijving)");
		$opdracht->bindParam(':naam', $naam);
		$opdracht->bindParam(':prijs', $prijs);
		$opdracht->bindParam(':voorraad', $voorraad);
		$opdracht->bindParam(':omschrijving', $omschrijving);
		if(isset($_POST["prijs"]))
		{
			$prijs = $_POST["prijs"];
		}
		if(isset($_POST["naam"]))
		{
			$naam = $_POST["naam"];
		}
		if(isset($_POST["voorraad"]))
		{
			$voorraad = $_POST["voorraad"];
		}
		if(isset($_POST["omschrijving"]))
		{
			$omschrijving= $_POST["omschrijving"];
		}
		// test of er waarden en getallen zijn
		// Voeg hier eigen commentaar toe.
		if( !empty($naam) && 
			  ((!empty($prijs) && is_numeric($prijs))||$prijs=="0") && 
			  ((!empty($voorraad) && is_numeric($voorraad))||$voorraad=="0") && 
			  !empty($omschrijving) ) 
		{    
			// Maak van prijs een double
			$prijs=(double)$prijs; 
			//Alle waarden voor de invoer zouden nu goed moeten zijn 
			// en zijn we nu klaar om de opdracht door te geven aan database
			$opdracht->execute();

			$uitvoer = toonArtikelInvoerTabel( array(
						array($naam,$fout1),
						array($prijs,$fout2),
						array($voorraad,$fout3),
						array($omschrijving,$fout4)
					),false);
			$uitvoer .= "Artikel is ingevoerd";
        }
		else // er is een fout
		{
		 // Voeg hier eigen commentaar toe. 
		 if(empty($naam)){$fout1="Er moet een naam worden ingevuld";}
		 if(empty($prijs)){$fout2="Er moet een getal worden ingevuld";}
		 elseif(!is_numeric($prijs)){$fout2="$prijs is geen getal";}
		 if(empty($voorraad)){$fout3="Er moet een getal worden ingevuld";}
		 elseif(!is_numeric($voorraad)){$fout3="$voorraad is geen getal";}
		 if(empty($omschrijving)){$fout4="Er moet een omschrijving worden ingevuld";}
		 
		 $uitvoer = toonArtikelInvoerTabel( array(
						array($naam,$fout1),
						array($prijs,$fout2),
						array($voorraad,$fout3),
						array($omschrijving,$fout4)
					),true);
		}
    }
   	catch(PDOException $e) {  // Er is een fout opgetreden in SQL
		$uitvoer = toonArtikelInvoerTabel( array(
			array($naam,$fout1),
			array($prijs,$fout2),
			array($voorraad,$fout3),
			array($omschrijving,$fout4)
			),true);
		$uitvoer .= "Fout uitvoeren query!<br/>";
	    $uitvoer .= $e->getMessage();
    }
	//sluit database
	verbreekVerbinding($db);
  }
  return $uitvoer;
}
?>