<?php
//  sla op als database.php
/*  eerst definieren we twee global variabelen $db en $melding.
    Een global variabele is een variabele die we overal in de code
    kunnen benaderen. Voordelen van een global variabele zijn
    dat een dergelijke variabele overal vanuit de code benaderbaar is
    en dat er communicatie mogelijk is vanuit verschillende 
    functies met behulp van deze variabelen zonder dat de functie
    argumnenten nodig heeft.
    Een groot nadeel is dat het naarmate projecten groter worden
    lastig is om globale variabelen goed in het oog te houden.
*/
global $melding; // zal worden gebruikt voor foutmeldingen in database functies
global $db;      // zal worden gebruikt om een database connectie in op te slaan
$melding = "";    // zet de melding eerst op leeg
$db=null;        // zet de connectie eerst op null

function maakVerbinding()
{
   global $melding; // zorg dat je de globale variabele $melding gaat gebruiken
   global $db;        // zorg dat je de globale variabele $db gaat gebruiken
   $server = "localhost";
   $user = "leerling";
   $wachtwoord = "rloleerling";
   $database ="garagebedrijf"; 
   if($db !== null)
   {
      $melding = "Er is al een verbinding";
   }
   else
   {
      try {
        $db = new PDO("mysql:host=$server;dbname=$database", $user, $wachtwoord);
        // set the PDO error mode to exception
        $db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        $melding = "Connectie met database gemaakt";
        
      } catch(PDOException $e) {
        $melding = "Helaas, mysql kan geen verbinding maken: " . $e->getMessage();
        $db = null;
      }
   }
    return $db;
}
/*
 verbreekVerbinding verbreekt de connectie met de mysql server en
 zet de globale variabele $db weer op de startwaarde.
 */
function verbreekVerbinding()
{
 global $db;
 if($db)
 {
   $db=null;
 }
}

?>
